var nestedChar;
function LabelData(label,children){
	this.title=label;
	this.type=0
	this.open=false;
	this.date=0;
	this.level=0;
	this.fullTitle=label;
	children=children ? children: true;
	if (children)
		this.data=bookmarkArray.getBookmarksByLabel(label);
	else
		this.data=new Array();
	
	for (var i=0;i<this.data.length;i++){
		if (this.data[i].date>this.date) this.date=this.data[i].date;	
	}
	//dump(label+"[length]: "+this.data.length+"\n");
}
function BookmarkData(type,bkmk, level){
	this.type=type;
	this.level=level? level : type-1;
	this.title=bkmk.title;
	this.id=bkmk.id;
	this.url=bkmk.url;
	this.labels=bkmk.labels;
	this.notes=bkmk.notes;
	this.image=bkmk.image;
}

function getVisibleData(){
	dump("getVisibleData\n");
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                        getService(Components.interfaces.nsIPrefService).getBranch("gmarks.");
	nestedChar=prefs.getCharPref("nestedChar");
	var ret=bookmarkArray.getLabelsData();
	
	ret=mergeTree(ret);
	
	if (sortby=="date"){
		ret.sort(function (x, y){ 	
			if (x.date < y.date)
				return 1;
			else if (x.date > y.date)
				return -1;
			return 0; 
		});
	}
    //Add bookmarks with no label
    var unlabeled=bookmarkArray.getUnlabeled();
    for (var n=0;n<unlabeled.length;n++)
    	ret.push(new BookmarkData(1,unlabeled[n]));
    
    return ret;
}

function mergeTree(ret){
	for (var i=0;i<ret.length;i++){
		var label=ret[i].fullTitle;
		var pos=label.indexOf(nestedChar);
		if (pos>1 && pos!=label.length-1){
			var parent=label.substring(0,pos);
			//Find parent
			if (i>0 && ret[i-1].title==parent){
				//dump('ret: '+ret[i].title+'\n');
				ret[i-1]=mergeLabels(ret[i],ret[i-1]);
				ret.splice(i,1);
				i--;
			}
			else{
				ret.splice(i,0,new LabelData(parent,false));
				ret[i]=mergeLabels(ret[i+1],ret[i]);
				ret.splice(i+1,1);	
			}
		}		
	}	
	return ret;
}

function mergeLabels(child,parent){
	//dump("parent="+parent.fullTitle+"\n");
	//dump('child: '+child.title+"\n");
	var pos=child.title.indexOf(nestedChar);
	child.title=child.title.substring(pos+1);
	child.level++;
	//dump("level: "+child.level+"\n");
	pos=child.title.indexOf(nestedChar);
	//dump("pos="+pos+"\n");
	if (pos>1 && pos!=child.title.length-1){
		var title=child.title.substring(0,pos);
		var fullTitle;
		//child.title=child.title.substring(pos+1);
		
		var pos2=-1;
		
		for (var i=0;i<=child.level;i++){
			pos2=child.fullTitle.substring(pos2+1).indexOf(nestedChar)+pos2+1;
		}
		fullTitle=child.fullTitle.substring(0,pos2);

		var found=false;
		
		for (var i=0;i<parent.data.length;i++){
			if (parent.data[i].type==0 && parent.data[i].fullTitle==fullTitle){	
				//dump("fulltitle="+fullTitle+"| title="+title+"\n");
				parent.data[i]=mergeLabels(child,parent.data[i]);
				found=true;
				break;
			}
		}
		
		//if (found) dump("existing label found! ("+title+")\n"); else dump("no existing label found ("+title+"|"+fullTitle+")\n");
		if (!found){
			var newLabel=new LabelData(title,false);
			newLabel.level=child.level-1;
			newLabel.fullTitle=child.fullTitle.substring(0,pos2);
			newLabel=mergeLabels(child,newLabel);
			parent=mergeLabels(newLabel,parent);
		}
	}
	else
	{
		if (child.date > parent.date && child.date>0)
		{
			//dump("--------------------------\n"+parent.title+" date changed to "+child.date+"\n----------------------\n");
			parent.date=child.date;
		}
		if (parent.data.length==0){
			parent.data.push(child);	
		}
		else {
			for (var i=0;i<parent.data.length;i++){
				if (parent.data[i].type!=0){
					//insert
					parent.data.splice(i,0,child);
					break;
				}
				else if (i==parent.data.length-1){
					parent.data.push(child);	
					break
				}
			}	
		}
	}
	
	return parent;
}